#pragma once

/*#pragma pack(4)
struct C_user_type
{
	short iVal;
	double dVal;
	double bstr; // VBA String type is a byte string
};
#pragma pack()
*/

#ifdef BMDS_ENTRY_EXPORTS
#define BMDS_ENTRY_API __declspec(dllexport)
#else
#define BMDS_ENTRY_API __declspec(dllimport)
#endif

namespace BmdsEntry
{
	double bmd_log_logistic(
		const  double *d_y, const  double* d_x, const int n) {

		Eigen::MatrixXd  Y(n, 1); Eigen::MatrixXd  X(n, 1);

		for (int i = 0; i < n; i++) {
			Y(i, 0) = d_y[i]; X(i, 0) = d_x[i];
		}

		Eigen::MatrixXd priors(3, 5);
		priors << 1.0, -2.0, 1.0, -18.0, 18.0,
			1.0, 0, 1.0, -18, 18.0,
			2.0, 0, .5, 1e-4, 18.0;

		bmd_analysis a = bmd_analysis_NC<dich_loglogisticModelNC, IDbinomPrior>(Y, X, priors,
			0.1, true,
			0.01, 0.05);

		return a.MAP_BMD;

	}

}