#pragma once

#define BGINDEX      1		/* Index for background parameter */
#define PHISTART     6		/* Start of phi (ILC) parameters */
#define THETA1_INDEX 3		/* Index of theta1 parm */
#define THETA2_INDEX 4		/* Index of theta2 parm */
#define DEBUGOUT(fp, x) fprintf(fp, "%s:%d: %s\n", __FILE__, __LINE__, (x))

// This replaces the BMDS ERRORPRT() function call
#define MY_ERROR(x); {						\
  fprintf(stderr, "\n%s:%d: %s\n", __FILE__, __LINE__, (x));	\
  fprintf(fp_out, "\n%s:%s: %s\n", __FILE__, __LINE__, (x));	\
  fflush(stderr); fflush(fp_out);                               \
  exit(0);                                                      \
}

/* Function declarations */
void Predict(double [], double [], int, double [], double []);
int Model_DF (int []);
void myPrintText(FILE *fp, const char *pText);
void myPrintInitParms(FILE *fp, int nparm, int Spec[], double Parms[], char *tparms[]);
void myErrorPrt(FILE *fp, const char *text);
void myWarning(FILE *fp, const char *text);
void myOUTPUT_DTMS3PARMS (int nparm, int Spec[], int bounded[], double Parms[],
			  const char *tparms[], double **vcv, int print_SE);
void myGet_and_OUTPUT_DTMSVCV (int nparm, int Spec[], char *parmtxt[],
			       double **vcv, double **vcv_adj, int *bounded);
void myOUTPUT_DTMS3ANOVA (char *anatxt[], AnaList anasum[]);
void my_do_dmngb_warning(FILE *fp, int * eflag);
void myGoodness (NDichotomous_Result_t *zOut, int ngrp, int nparm, double Parms[],
		 int bounded[], int Nobs, double Xi[], double Yp[], double Yn[],
		 double Ls[], int Xg[], double SR[] );
void myBootstrap (NDichotomous_Result_t *zOut, int ngrp, int nparm, double Parms[], int bounded[],
		  int Nobs, double Xi[], double Yp[], double Yn[], double Ls[],
		  int Xg[], double SR[], int BSIter, long BSSeed );
void mySRoI (NDichotomous_Result_t *zOut, int ngrp, int Nobs, double GXi[], double Xi[], int Xg[], double SR[], double LSC[], double meanLSC, double BMD);
