
//#include <Windows.h>
#include <stdio.h>
#include <string.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <sstream>
#include <vector>
//#include "pch.h"
#include "bmds_ms_combo_entry.h"

using namespace std;

int main(int argc, char *argv[])
{
  // HARDCODE n for now. Remove const property when n becomes dynamic!
  const int n = 3; // Number of datasets
  double background = -9999; // Default to estimated
  int dg = 0; // Number of dose groups
  vector<BMDSDataSet_t> vInputData;
  if (argc < 3) {
    cout << "Usage: " << (strrchr(argv[0], '\\') + 1) << " input_file bmr [background]" << endl;
    return (-1);
  }
  if (argc > 3) {
    string strBackground(argv[4]);
    background = stod(strBackground, NULL);
  }
  ifstream input(argv[1]);
  string data;
  std::string::size_type sz;
  string string_bmr(argv[2]);
  MSCombo_Options_t zOpts;
  zOpts.bmrType = eExtraRisk; // *** HARD CODE risk type for now ***
  zOpts.bmr = stod(string_bmr, &sz);
  zOpts.alpha = 0.05; // *** HARD CODE for now ***

  // Hard code the input datasets
  BMDSDataRow_t ds1Rows[] = { {0, 0, 100}, {50, 5, 100},
    {100, 30, 100}, {150, 65, 100}, {200, 90, 100}
  };
  BMDSDataRow_t ds2Rows[] = { {0, 5, 100}, {50, 10, 100},
    {100, 33, 100}, {150, 67, 100}, {200, 93, 100}
  };
  BMDSDataRow_t ds3Rows[] = { {0, 1, 100}, {50, 68, 100},
    {100, 78, 100}, {150, 88, 100}, {200, 98, 100}
  };
  BMDSDataSet_t ds[n];

  ds[0].rows = ds1Rows;
  ds[0].count = 5;
  ds[0].degree = 2;
  ds[0].background = -9999;
  ds[1].rows = ds2Rows;
  ds[1].count = 5;
  ds[1].degree = 2;
  ds[1].background = -9999;
  ds[2].rows = ds3Rows;
  ds[2].count = 5;
  ds[2].degree = 2;
  ds[2].background = -9999;

  // Allocate storage for the output. Don't worry about the MLE parms
  // because they are not returned.
  BMD_ANAL_t zTumors[n];
  MSCombo_Result_t zResult;
  zResult.dsResults = zTumors;
  int status;
  cout << "Running multi-tumor analysis... " << endl;
  status = ms_combo(&zResult, n, ds, &zOpts);
  cout << "ms_combo run completed\n" << endl;

  return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
